#include <bits/stdc++.h>

using namespace std;

int mennyi(int szam)
{
    int index=0;
    while(szam>1)
    {
        szam>>=1;
        index++;
    }

    return index;
}

int main()
{
    int n,q;



    cin>>n>>q;

    vector<int> a(n);

    for(int i=0; i<n; i++)
    {
        cin>>a[i];
    }

    int bal, jobb;
    map<int,int> szamol;

    for(int i=0; i<q; i++)
    {
        cin>>bal>>jobb;

        for(int j=bal-1; j<=jobb-1; j++)
        {
            szamol[mennyi(a[j])]++;
        }

        int nagy=0;
        for(auto it:szamol)
        {
            if(it.second>nagy)
            {
                nagy=it.second;
            }
        }

        cout<<nagy<<endl;

        szamol.clear();


    }


    return 0;
}